package JCheck;
/*
 * Created on Mar 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
import java.util.*;
public class Main {

	/**
	 * Calculates MINMAX value for initial state by searching 
	 * till a depth of ply.
	 * @param ply
	 */
	public static void ABTest(int ply) {
		Search.START_TIME = System.currentTimeMillis();
		Search.TIME_LIMIT = Long.MAX_VALUE;
		State s0 = new State(State.INITIAL_STATE);
		System.out.println(
			"g="
				+ Search.AlphaBeta(
					s0,
					Short.MIN_VALUE,
					Short.MAX_VALUE,
					(short) ply));
		System.out.println(
			"expanded: " + Search.count + " pruned: " + Search.pruned);
		System.out.println(System.currentTimeMillis() - Search.START_TIME);
	}

	/**
	 * Plays a game with a human. iStart iff computer starts, redStarts iff 
	 * red starts.
	 * @param iStart
	 * @param redStarts
	 */
	public static void playGame(boolean iStart, boolean redStarts) {
		int c = 0;
		byte[] mArray;

		if (!iStart)
			c = 1;
		State.INITIAL_STATE.redMove = redStarts;

		State currentState = new State(State.INITIAL_STATE),
			newState = null,
			oldState = null;
		while (currentState != null && !State.isDone(currentState)) {
			System.out.println("move: " + c);
			System.out.println(currentState);
			if (c % 2 == 0) {
				newState = Search.Decision(currentState);
				c++;
			} else {
				System.out.println("Enter Move | UNDO");
				String mv = stdio.getLine();
				if (mv.equals("UNDO")) {
					newState = oldState;
				} else {
					try {
						//parsing routine
						Vector v = new Vector();
						int lastDash = 0;
						for (int i = 0; i < mv.length(); i++) {
							if (mv.charAt(i) == '-') {
								v.add(mv.substring(lastDash, i));
								lastDash = i;
							}
						}
						v.add(mv.substring(lastDash + 1));
						mArray = new byte[v.size()];
						for (int i = 0; i < mArray.length; i++) {
							mArray[i] =
								State.BYTE[stdio.parseInt(
									(String) v.elementAt(i))];
						}
					} catch (Exception e) {
						System.out.println("Invalid Input");
						continue;
					}
					oldState = currentState;
					newState = new State(currentState);
					if (State.applyMove(newState, mArray))
						c++;
				}
			}
			currentState = newState;
		}
		if (State.isDone(currentState) && currentState.redMove) {
			System.out.println("red loses");
		} else {
			System.out.println("white loses");
		}

	}

	public static void main(String[] args) {
		System.out.println("-------------ABTest----------");
		//ABTest(12);	
		System.out.println("-------------GameTest----------");
		//playGame(true,false);
		System.out.println("-------------SelfTest----------");
		PWSelf(true);
	}

	/**
	 * Plays a game with itself. redStarts iff red starts.
	 * @param redStarts
	 */
	public static void PWSelf(boolean redStarts) {
		State.INITIAL_STATE.redMove = redStarts;
		State currentState = new State(State.INITIAL_STATE),
			newState = null,
			oldState = null;
		int c = 0;
		while (currentState != null && !State.isDone(currentState)) {
			System.out.println("move: " + c / 2);
			System.out.println(currentState);
			newState = Search.Decision(currentState);
			oldState = currentState;
			currentState = newState;
			c++;
		}

		if (oldState.redMove) {
			System.out.println("red loses");
		} else {
			System.out.println("white loses");
		}

	}
}
