/*
 * Created on Mar 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

package JCheck;
import java.util.*;

public class Search {
	private static Map T;
	public static int count, pruned;
	public static long START_TIME;
	public static long TIME_LIMIT = 5000;
	public static boolean TIMEOUT = false;
	public static int CURRENT_VALUE;

	static {
		T = new HashMap();
		count = 0;
		pruned = 0;
	}

	public static State ABDecision(State n, int ply) {
		Stack succ = State.makeSuccessors(n);
		State k = null, bestState = null;
		int bestValue, v;
		if (n.redMove) {
			bestValue = Short.MIN_VALUE;
			while (!succ.isEmpty() && !TIMEOUT) {
				k = succ.pop();
				v = AlphaBeta(k, Short.MIN_VALUE, Short.MAX_VALUE, ply);
				if (v > bestValue) {
					bestValue = v;
					bestState = k;
				}
			}
		} else {
			bestValue = Short.MAX_VALUE;
			while (!succ.isEmpty() && !TIMEOUT) {
				k = succ.pop();
				v = AlphaBeta(k, Short.MIN_VALUE, Short.MAX_VALUE, ply);
				if (v < bestValue) {
					bestValue = v;
					bestState = k;
				}
			}
		}
		CURRENT_VALUE = bestValue;
		return bestState;
	}

	public static State Decision(State n) {
		START_TIME = System.currentTimeMillis();
		State bestDecision = ABDecision(n, 7), d;
		int bestValue = CURRENT_VALUE;
		if (!TIMEOUT) {
			System.out.println("OK");
		}
		int ply = 8;
		while (System.currentTimeMillis() - START_TIME < TIME_LIMIT) {
			TIMEOUT = false;
			d = ABDecision(n, ply);
			if (!TIMEOUT) {
				bestDecision = d;
				bestValue = CURRENT_VALUE;
				System.out.println(
					"FINISHED PLY: "
						+ (ply++)
						+ " "
						+ (System.currentTimeMillis() - START_TIME)
						+ "ms");
			}
		}
		System.out.println("h: "+bestValue);
		return bestDecision;
	}

	public static int AlphaBeta(State n, int alpha, int beta, int depth) {
		//if timeout, return
		if (System.currentTimeMillis() - START_TIME > TIME_LIMIT) {
			TIMEOUT = true;
			return 0;
		}
		if (depth == 0)
			return State.evaluate(n);
		Stack kids = State.makeSuccessors(n);
		count++;
		/*if (count % 1000000 == 0)
			System.out.print(".");*/
		State k;
		int val;
		while (!kids.isEmpty()) {
			k = kids.pop();
			val = -AlphaBeta(k, -beta, -alpha, depth - 1);
			if (val >= beta) {
				pruned++;
				return beta;
			}
			if (val > alpha)
				alpha = val;
		}
		return alpha;
	}

}
