package JCheck;
import java.util.*;
public class State {

	public static final byte[] BYTE;
	public static final State INITIAL_STATE;
	private static final int KING_INIT = 0;
	public static final int[] MASKS;
	public static final int CENTRAL, RED_BACK, WHITE_BACK;

	private static final byte RED_END = 29;
	private static final byte WHITE_END = 4;
	private static final int WHITE_INIT = -1048576;
	private static final int RED_INIT = 4095;
	private static final Random r;

	/**
	 * Contains manhattan distances between squares.
	 */
	private static final int[][] MD =
		{
			{
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0,
				0 },
			{
			0,
				0,
				2,
				4,
				6,
				1,
				1,
				3,
				5,
				2,
				2,
				4,
				6,
				3,
				3,
				3,
				5,
				4,
				4,
				4,
				6,
				5,
				5,
				5,
				5,
				6,
				6,
				6,
				6,
				7,
				7,
				7,
				7 },
				{
			0,
				2,
				0,
				2,
				4,
				3,
				1,
				1,
				3,
				2,
				2,
				2,
				4,
				3,
				3,
				3,
				3,
				4,
				4,
				4,
				4,
				5,
				5,
				5,
				5,
				6,
				6,
				6,
				6,
				7,
				7,
				7,
				7 },
				{
			0,
				4,
				2,
				0,
				2,
				5,
				3,
				1,
				1,
				4,
				2,
				2,
				2,
				5,
				3,
				3,
				3,
				4,
				4,
				4,
				4,
				5,
				5,
				5,
				5,
				6,
				6,
				6,
				6,
				7,
				7,
				7,
				7 },
				{
			0,
				6,
				4,
				2,
				0,
				7,
				5,
				3,
				1,
				6,
				4,
				2,
				2,
				7,
				5,
				3,
				3,
				6,
				4,
				4,
				4,
				7,
				5,
				5,
				5,
				6,
				6,
				6,
				6,
				7,
				7,
				7,
				7 },
				{
			0,
				1,
				3,
				5,
				7,
				0,
				2,
				4,
				6,
				1,
				3,
				5,
				7,
				2,
				2,
				4,
				6,
				3,
				3,
				5,
				7,
				4,
				4,
				4,
				6,
				5,
				5,
				5,
				7,
				6,
				6,
				6,
				6 },
				{
			0,
				1,
				1,
				3,
				5,
				2,
				0,
				2,
				4,
				1,
				1,
				3,
				5,
				2,
				2,
				2,
				4,
				3,
				3,
				3,
				5,
				4,
				4,
				4,
				4,
				5,
				5,
				5,
				5,
				6,
				6,
				6,
				6 },
				{
			0,
				3,
				1,
				1,
				3,
				4,
				2,
				0,
				2,
				3,
				1,
				1,
				3,
				4,
				2,
				2,
				2,
				3,
				3,
				3,
				3,
				4,
				4,
				4,
				4,
				5,
				5,
				5,
				5,
				6,
				6,
				6,
				6 },
				{
			0,
				5,
				3,
				1,
				1,
				6,
				4,
				2,
				0,
				5,
				3,
				1,
				1,
				6,
				4,
				2,
				2,
				5,
				3,
				3,
				3,
				6,
				4,
				4,
				4,
				5,
				5,
				5,
				5,
				6,
				6,
				6,
				6 },
				{
			0,
				2,
				2,
				4,
				6,
				1,
				1,
				3,
				5,
				0,
				2,
				4,
				6,
				1,
				1,
				3,
				5,
				2,
				2,
				4,
				6,
				3,
				3,
				3,
				5,
				4,
				4,
				4,
				6,
				5,
				5,
				5,
				5 },
				{
			0,
				2,
				2,
				2,
				4,
				3,
				1,
				1,
				3,
				2,
				0,
				2,
				4,
				3,
				1,
				1,
				3,
				2,
				2,
				2,
				4,
				3,
				3,
				3,
				3,
				4,
				4,
				4,
				4,
				5,
				5,
				5,
				5 },
				{
			0,
				4,
				2,
				2,
				2,
				5,
				3,
				1,
				1,
				4,
				2,
				0,
				2,
				5,
				3,
				1,
				1,
				4,
				2,
				2,
				2,
				5,
				3,
				3,
				3,
				4,
				4,
				4,
				4,
				5,
				5,
				5,
				5 },
				{
			0,
				6,
				4,
				2,
				2,
				7,
				5,
				3,
				1,
				6,
				4,
				2,
				0,
				7,
				5,
				3,
				1,
				6,
				4,
				2,
				2,
				7,
				5,
				3,
				3,
				6,
				4,
				4,
				4,
				7,
				5,
				5,
				5 },
				{
			0,
				3,
				3,
				5,
				7,
				2,
				2,
				4,
				6,
				1,
				3,
				5,
				7,
				0,
				2,
				4,
				6,
				1,
				3,
				5,
				7,
				2,
				2,
				4,
				6,
				3,
				3,
				5,
				7,
				4,
				4,
				4,
				6 },
				{
			0,
				3,
				3,
				3,
				5,
				2,
				2,
				2,
				4,
				1,
				1,
				3,
				5,
				2,
				0,
				2,
				4,
				1,
				1,
				3,
				5,
				2,
				2,
				2,
				4,
				3,
				3,
				3,
				5,
				4,
				4,
				4,
				4 },
				{
			0,
				3,
				3,
				3,
				3,
				4,
				2,
				2,
				2,
				3,
				1,
				1,
				3,
				4,
				2,
				0,
				2,
				3,
				1,
				1,
				3,
				4,
				2,
				2,
				2,
				3,
				3,
				3,
				3,
				4,
				4,
				4,
				4 },
				{
			0,
				5,
				3,
				3,
				3,
				6,
				4,
				2,
				2,
				5,
				3,
				1,
				1,
				6,
				4,
				2,
				0,
				5,
				3,
				1,
				1,
				6,
				4,
				2,
				2,
				5,
				3,
				3,
				3,
				6,
				4,
				4,
				4 },
				{
			0,
				4,
				4,
				4,
				6,
				3,
				3,
				3,
				5,
				2,
				2,
				4,
				6,
				1,
				1,
				3,
				5,
				0,
				2,
				4,
				6,
				1,
				1,
				3,
				5,
				2,
				2,
				4,
				6,
				3,
				3,
				3,
				5 },
				{
			0,
				4,
				4,
				4,
				4,
				3,
				3,
				3,
				3,
				2,
				2,
				2,
				4,
				3,
				1,
				1,
				3,
				2,
				0,
				2,
				4,
				3,
				1,
				1,
				3,
				2,
				2,
				2,
				4,
				3,
				3,
				3,
				3 },
				{
			0,
				4,
				4,
				4,
				4,
				5,
				3,
				3,
				3,
				4,
				2,
				2,
				2,
				5,
				3,
				1,
				1,
				4,
				2,
				0,
				2,
				5,
				3,
				1,
				1,
				4,
				2,
				2,
				2,
				5,
				3,
				3,
				3 },
				{
			0,
				6,
				4,
				4,
				4,
				7,
				5,
				3,
				3,
				6,
				4,
				2,
				2,
				7,
				5,
				3,
				1,
				6,
				4,
				2,
				0,
				7,
				5,
				3,
				1,
				6,
				4,
				2,
				2,
				7,
				5,
				3,
				3 },
				{
			0,
				5,
				5,
				5,
				7,
				4,
				4,
				4,
				6,
				3,
				3,
				5,
				7,
				2,
				2,
				4,
				6,
				1,
				3,
				5,
				7,
				0,
				2,
				4,
				6,
				1,
				3,
				5,
				7,
				2,
				2,
				4,
				6 },
				{
			0,
				5,
				5,
				5,
				5,
				4,
				4,
				4,
				4,
				3,
				3,
				3,
				5,
				2,
				2,
				2,
				4,
				1,
				1,
				3,
				5,
				2,
				0,
				2,
				4,
				1,
				1,
				3,
				5,
				2,
				2,
				2,
				4 },
				{
			0,
				5,
				5,
				5,
				5,
				4,
				4,
				4,
				4,
				3,
				3,
				3,
				3,
				4,
				2,
				2,
				2,
				3,
				1,
				1,
				3,
				4,
				2,
				0,
				2,
				3,
				1,
				1,
				3,
				4,
				2,
				2,
				2 },
				{
			0,
				5,
				5,
				5,
				5,
				6,
				4,
				4,
				4,
				5,
				3,
				3,
				3,
				6,
				4,
				2,
				2,
				5,
				3,
				1,
				1,
				6,
				4,
				2,
				0,
				5,
				3,
				1,
				1,
				6,
				4,
				2,
				2 },
				{
			0,
				6,
				6,
				6,
				6,
				5,
				5,
				5,
				5,
				4,
				4,
				4,
				6,
				3,
				3,
				3,
				5,
				2,
				2,
				4,
				6,
				1,
				1,
				3,
				5,
				0,
				2,
				4,
				6,
				1,
				1,
				3,
				5 },
				{
			0,
				6,
				6,
				6,
				6,
				5,
				5,
				5,
				5,
				4,
				4,
				4,
				4,
				3,
				3,
				3,
				3,
				2,
				2,
				2,
				4,
				3,
				1,
				1,
				3,
				2,
				0,
				2,
				4,
				3,
				1,
				1,
				3 },
				{
			0,
				6,
				6,
				6,
				6,
				5,
				5,
				5,
				5,
				4,
				4,
				4,
				4,
				5,
				3,
				3,
				3,
				4,
				2,
				2,
				2,
				5,
				3,
				1,
				1,
				4,
				2,
				0,
				2,
				5,
				3,
				1,
				1 },
				{
			0,
				6,
				6,
				6,
				6,
				7,
				5,
				5,
				5,
				6,
				4,
				4,
				4,
				7,
				5,
				3,
				3,
				6,
				4,
				2,
				2,
				7,
				5,
				3,
				1,
				6,
				4,
				2,
				0,
				7,
				5,
				3,
				1 },
				{
			0,
				7,
				7,
				7,
				7,
				6,
				6,
				6,
				6,
				5,
				5,
				5,
				7,
				4,
				4,
				4,
				6,
				3,
				3,
				5,
				7,
				2,
				2,
				4,
				6,
				1,
				3,
				5,
				7,
				0,
				2,
				4,
				6 },
				{
			0,
				7,
				7,
				7,
				7,
				6,
				6,
				6,
				6,
				5,
				5,
				5,
				5,
				4,
				4,
				4,
				4,
				3,
				3,
				3,
				5,
				2,
				2,
				2,
				4,
				1,
				1,
				3,
				5,
				2,
				0,
				2,
				4 },
				{
			0,
				7,
				7,
				7,
				7,
				6,
				6,
				6,
				6,
				5,
				5,
				5,
				5,
				4,
				4,
				4,
				4,
				3,
				3,
				3,
				3,
				4,
				2,
				2,
				2,
				3,
				1,
				1,
				3,
				4,
				2,
				0,
				2 },
				{
			0,
				7,
				7,
				7,
				7,
				6,
				6,
				6,
				6,
				5,
				5,
				5,
				5,
				6,
				4,
				4,
				4,
				5,
				3,
				3,
				3,
				6,
				4,
				2,
				2,
				5,
				3,
				1,
				1,
				6,
				4,
				2,
				0 }
	};

	/**
	 * Contains legal successor positions for each board position
	 */
	public static final byte[][] S = { { 0, 0, 0, 0, 0 }, {
			0, 0, 0, 5, 6 }, {
			0, 0, 0, 6, 7 }, {
			0, 0, 0, 7, 8 }, {
			0, 0, 0, 8, 0 }, {
			0, 0, 1, 0, 9 }, {
			0, 1, 2, 9, 10 }, {
			0, 2, 3, 10, 11 }, {
			0, 3, 4, 11, 12 }, {
			0, 5, 6, 13, 14 }, {
			0, 6, 7, 14, 15 }, {
			0, 7, 8, 15, 16 }, {
			0, 8, 0, 16, 0 }, {
			0, 0, 9, 0, 17 }, {
			0, 9, 10, 17, 18 }, {
			0, 10, 11, 18, 19 }, {
			0, 11, 12, 19, 20 }, {
			0, 13, 14, 21, 22 }, {
			0, 14, 15, 22, 23 }, {
			0, 15, 16, 23, 24 }, {
			0, 16, 0, 24, 0 }, {
			0, 0, 17, 0, 25 }, {
			0, 17, 18, 25, 26 }, {
			0, 18, 19, 26, 27 }, {
			0, 19, 20, 27, 28 }, {
			0, 21, 22, 29, 30 }, {
			0, 22, 23, 30, 31 }, {
			0, 23, 24, 31, 32 }, {
			0, 24, 0, 32, 0 }, {
			0, 0, 25, 0, 0 }, {
			0, 25, 26, 0, 0 }, {
			0, 26, 27, 0, 0 }, {
			0, 27, 28, 0, 0 }
	};

	private static final Stack STK;
	public static Stack JSUCC;
	public static Stack WSUCC;

	static {
		//setup initial state
		INITIAL_STATE = new State();
		INITIAL_STATE.red = RED_INIT;
		INITIAL_STATE.white = WHITE_INIT;
		INITIAL_STATE.king = KING_INIT;
		//INITIAL_STATE.redMove = true;

		//define masks for bit positions
		MASKS = new int[32];
		for (int i = 0; i < 31; i++) {
			MASKS[i] = 1;
			for (int k = 0; k < i; k++) {
				MASKS[i] *= 2;
			}
		}
		MASKS[31] = -2147483648;

		//setup BYTE array
		BYTE = new byte[33];
		for (byte i = 0; i < 33; i++) {
			BYTE[i] = i;
		}

		STK = new Stack();
		r = new Random();
		CENTRAL = 0x00666600;
		RED_BACK = 0x0000000f;
		WHITE_BACK = 0xf0000000;
	}

	/**
	 * Jumps from m0 to m1. Does not check that provided jump is valid, just 
	 * sets bits. Does not handle king-making or king-moves.
	 * @param s
	 * @param m0
	 * @param m1
	 */
	private static void applyJump(State s, byte m0, byte m1) {
		//System.out.println("DEBUG: Jump " + m0 + " " + m1);
		byte mid = BYTE[(m0 + m1 - (2 * (((m1 - 1) / 4) % 2) - 1)) / 2];
		if (s.redMove) {
			//red's move
			s.white = setBit(s.white, mid, false);
			s.king = setBit(s.king, mid, false);
			s.red = setBit(s.red, m0, false);
			s.red = setBit(s.red, m1, true);
		} else {
			//white's move
			s.red = setBit(s.red, mid, false);
			s.king = setBit(s.king, mid, false);
			s.white = setBit(s.white, m0, false);
			s.white = setBit(s.white, m1, true);
		}
	}

	/**
	 * Applies a move to this state, represented as an array of positions.
	 * Does not check validity of move.
	 */
	public static boolean applyMove(State s, byte[] move) {
		boolean moveMade = false;
		if (move[0] == S[move[1]][1]
			|| move[0] == S[move[1]][2]
			|| move[0] == S[move[1]][3]
			|| move[0] == S[move[1]][4]) {
			//move is a walk
			moveMade = applyWalk(s, move[0], move[1]);
		} else {
			//move is a jump/multijump
			if (move.length == 2) {
				//move is a single jump
				applyJump(s, move[0], move[1]);
			} else {
				//move is a multijump
				for (int i = 0; i < move.length - 1; i++) {
					applyJump(s, move[i], move[i + 1]);
				}
			}
			//handle king-making
			if (!getBit(s.king, move[0])
				&& ((s.redMove && move[move.length - 1] >= RED_END)
					|| (!s.redMove && move[move.length - 1] <= WHITE_END))) {
				//king-making
				s.king = setBit(s.king, move[move.length - 1], true);
			}
			moveMade = true;
			//move king
			if (getBit(s.king, move[0])) {
				s.king = setBit(s.king, move[0], false);
				s.king = setBit(s.king, move[move.length - 1], true);
			}
		}
		if (moveMade) {
			//switch turn
			s.redMove = !s.redMove;
		}
		return moveMade;
	}

	/**
	 * Walks a piece from m0 to m1. Handles king-making and king-masks.
	 * Does not check if move is valid, only sets bits.
	 * @param s 
	 * @param m0
	 * @param m1
	 * @return true if move made, false otherwise
	 */
	private static boolean applyWalk(State s, byte m0, byte m1) {
		//System.out.println("DEBUG: Walk " + m0 + " " + m1);
		boolean moveMade = false;
		if (s.redMove && getBit(s.red, m0)) {
			//red's move
			s.red = setBit(s.red, m0, false);
			s.red = setBit(s.red, m1, true);
			if (m1 >= RED_END && !getBit(s.king, m0)) {
				//king-making
				s.king = setBit(s.king, m1, true);
			}
			moveMade = true;
		} else if (!s.redMove && getBit(s.white, m0)) {
			//white's move
			s.white = setBit(s.white, m0, false);
			s.white = setBit(s.white, m1, true);
			if (m1 <= WHITE_END && !getBit(s.king, m0)) {
				//king-making
				s.king = setBit(s.king, m1, true);
			}
			moveMade = true;
		}
		//move king mask
		if (moveMade && getBit(s.king, m0)) {
			s.king = setBit(s.king, m0, false);
			s.king = setBit(s.king, m1, true);
		}
		return moveMade;
	}

	/**
	 * Returns the value of the nth bit in b.
	 * @param b
	 * @param n
	 * @return
	 */
	public static boolean getBit(int b, int n) {
		return ((b >>> (n - 1)) % 2) != 0;
	}

	/**
	 * Makes successors for state s and puts them in WSUCC/JSUCC.
	 * @param s
	 */
	public static Stack makeSuccessors(State s) {
		Stack successors;
		WSUCC = new Stack();
		JSUCC = new Stack();
		for (byte i = 0; i < 33; i++) {
			makeSuccessors(s, i);
		}
		if (JSUCC.isEmpty()) {
			successors = WSUCC;
		} else {
			successors = JSUCC;
		}
		return successors;
	}

	/**
	 * Creates successors for the state s that involve moving the piece at position n,
	 * and puts them in State.JSUCC and State.WSUCC.
	 * @param s
	 * @param n
	 */
	public static void makeSuccessors(State s, byte n) {
		//if no piece, no successors
		if ((s.redMove && !getBit(s.red, n))
			|| (!s.redMove && !getBit(s.white, n)))
			return;

		byte src, neighbor, target; //temp vars to keep track of moves
		final int blank = ~s.red & ~s.white;
		boolean walksAllowed = JSUCC.isEmpty();
		State s0, s1; //temp states to generate successors

		if (s.redMove && !getBit(s.king, n)) {
			////////////////////////////////////////////////////////////////////////RED PIECE
			STK.clear();
			//walk & singlejump
			for (byte i = 3; i <= 4; i++) {
				neighbor = S[n][i];
				target = S[neighbor][i];
				if (neighbor != 0) {
					if (walksAllowed && getBit(blank, neighbor)) {
						//walk: neighbor blank
						s0 = new State(s);
						s0.red = setBit(s0.red, n, false);
						s0.red = setBit(s0.red, neighbor, true);
						//king-making
						if (!getBit(s.king, n) && neighbor >= RED_END) {
							s0.king = setBit(s0.king, neighbor, true);
						}
						//add state to successors
						s0.redMove = !s0.redMove;
						WSUCC.push(s0);
					} else if (
						getBit(s.white, neighbor)
							&& target != 0
							&& getBit(blank, target)) {
						//jump available
						s0 = new State(s);
						s0.red = setBit(s0.red, n, false);
						s0.red = setBit(s0.red, target, true);
						s0.white = setBit(s0.white, neighbor, false);
						s0.king = setBit(s0.king, neighbor, false);
						s0.activePos = target;
						STK.push(s0);
					}
				}
			}
			//multijumps
			while (!STK.isEmpty()) {
				s0 = STK.pop();
				src = s0.activePos;
				//check king-making (which will cause end of multijump)
				if (!getBit(s0.king, src) && src >= RED_END) {
					s0.king = setBit(s0.king, src, true);
					s0.redMove = !s0.redMove;
					JSUCC.push(s0);
				} else {
					//check jumps
					boolean noJumps = true;
					for (byte i = 3; i <= 4; i++) {
						neighbor = S[src][i];
						target = S[neighbor][i];
						if (getBit(s0.white, neighbor)
							&& target != 0
							&& getBit(blank, target)) {
							noJumps = false;
							s1 = new State(s0);
							s1.red = setBit(s1.red, src, false);
							s1.red = setBit(s1.red, target, true);
							s1.white = setBit(s1.white, neighbor, false);
							s1.king = setBit(s1.king, neighbor, false);
							s1.activePos = target;
							STK.push(s1);
						}
					}
					if (noJumps) {
						s0.redMove = !s0.redMove;
						JSUCC.push(s0);
					}
				}
			}
		} else if (!s.redMove && !getBit(s.king, n)) {
			////////////////////////////////////////////////////////////////////////WHITE PIECE
			STK.clear();

			//walk & singlejump
			for (byte i = 1; i <= 2; i++) {
				neighbor = S[n][i];
				target = S[neighbor][i];
				if (neighbor != 0) {
					if (walksAllowed && getBit(blank, neighbor)) {
						//walk: neighbor blank
						s0 = new State(s);
						s0.white = setBit(s0.white, n, false);
						s0.white = setBit(s0.white, neighbor, true);
						//king-making
						if (!getBit(s.king, n) && neighbor <= WHITE_END) {
							s0.king = setBit(s0.king, neighbor, true);
						}
						//add state to successors
						s0.redMove = !s0.redMove;
						WSUCC.push(s0);
					} else if (
						getBit(s.red, neighbor)
							&& target != 0
							&& getBit(blank, target)) {
						//jump available
						s0 = new State(s);
						s0.white = setBit(s0.white, n, false);
						s0.white = setBit(s0.white, target, true);
						s0.red = setBit(s0.red, neighbor, false);
						s0.king = setBit(s0.king, neighbor, false);
						s0.activePos = target;
						STK.push(s0);
					}
				}
			}
			//multijumps
			while (!STK.isEmpty()) {
				s0 = STK.pop();
				src = s0.activePos;
				//check king-making (which will cause end of multijump)
				if (!getBit(s0.king, src) && src <= WHITE_END) {
					s0.king = setBit(s0.king, src, true);
					s0.redMove = !s0.redMove;
					JSUCC.push(s0);
				} else {
					//check jumps
					boolean noJumps = true;
					for (byte i = 1; i <= 2; i++) {
						neighbor = S[src][i];
						target = S[neighbor][i];
						if (getBit(s0.red, neighbor)
							&& target != 0
							&& getBit(blank, target)) {
							noJumps = false;
							s1 = new State(s0);
							s1.white = setBit(s1.white, src, false);
							s1.white = setBit(s1.white, target, true);
							s1.red = setBit(s1.red, neighbor, false);
							s1.king = setBit(s1.king, neighbor, false);
							s1.activePos = target;
							STK.push(s1);
						}
					}
					if (noJumps) {
						s0.redMove = !s0.redMove;
						JSUCC.push(s0);
					}
				}
			}
		} else if (s.redMove && getBit(s.king, n)) {
			////////////////////////////////////////////////////////////////////////RED KING
			STK.clear();
			//walk & singlejump
			for (byte i = 1; i <= 4; i++) {
				neighbor = S[n][i];
				target = S[neighbor][i];
				if (neighbor != 0) {
					if (walksAllowed && getBit(blank, neighbor)) {
						//walk: neighbor blank
						s0 = new State(s);
						s0.red = setBit(s0.red, n, false);
						s0.red = setBit(s0.red, neighbor, true);
						s0.king = setBit(s0.king, n, false);
						s0.king = setBit(s0.king, neighbor, true);
						//add state to successors
						s0.redMove = !s0.redMove;
						WSUCC.push(s0);
					} else if (
						getBit(s.white, neighbor)
							&& target != 0
							&& getBit(blank, target)) {
						//jump available
						s0 = new State(s);
						s0.red = setBit(s0.red, n, false);
						s0.red = setBit(s0.red, target, true);
						s0.white = setBit(s0.white, neighbor, false);
						s0.king = setBit(s0.king, neighbor, false);
						s0.activePos = target;
						STK.push(s0);
					}
				}
			}
			//multijumps
			while (!STK.isEmpty()) {
				s0 = STK.pop();
				src = s0.activePos;
				//check jumps
				boolean noJumps = true;
				for (byte i = 1; i <= 4; i++) {
					neighbor = S[src][i];
					target = S[neighbor][i];
					if (getBit(s0.white, neighbor)
						&& target != 0
						&& getBit(blank, target)) {
						noJumps = false;
						s1 = new State(s0);
						s1.red = setBit(s1.red, src, false);
						s1.red = setBit(s1.red, target, true);
						s1.white = setBit(s1.white, neighbor, false);
						s1.king = setBit(s1.king, neighbor, false);
						s1.activePos = target;
						STK.push(s1);
					}
				}
				if (noJumps) {
					s0.redMove = !s0.redMove;
					s0.king = setBit(s0.king, n, false);
					s0.king = setBit(s0.king, src, true);
					JSUCC.push(s0);
				}
			}
		} else {
			////////////////////////////////////////////////////////////////////////WHITE KING
			STK.clear();

			//walk & singlejump
			for (byte i = 1; i <= 4; i++) {
				neighbor = S[n][i];
				target = S[neighbor][i];
				if (neighbor != 0) {
					if (walksAllowed && getBit(blank, neighbor)) {
						//walk: neighbor blank
						s0 = new State(s);
						s0.white = setBit(s0.white, n, false);
						s0.white = setBit(s0.white, neighbor, true);
						s0.king = setBit(s0.king, n, false);
						s0.king = setBit(s0.king, neighbor, true);
						//add state to successors
						s0.redMove = !s0.redMove;
						WSUCC.push(s0);
					} else if (
						getBit(s.red, neighbor)
							&& target != 0
							&& getBit(blank, target)) {
						//jump available
						s0 = new State(s);
						s0.white = setBit(s0.white, n, false);
						s0.white = setBit(s0.white, target, true);
						s0.red = setBit(s0.red, neighbor, false);
						s0.king = setBit(s0.king, neighbor, false);
						s0.activePos = target;
						STK.push(s0);
					}
				}
			}
			//multijumps
			while (!STK.isEmpty()) {
				s0 = STK.pop();
				src = s0.activePos;
				//check jumps
				boolean noJumps = true;
				for (byte i = 1; i <= 4; i++) {
					neighbor = S[src][i];
					target = S[neighbor][i];
					if (getBit(s0.red, neighbor)
						&& target != 0
						&& getBit(blank, target)) {
						noJumps = false;
						s1 = new State(s0);
						s1.white = setBit(s1.white, src, false);
						s1.white = setBit(s1.white, target, true);
						s1.red = setBit(s1.red, neighbor, false);
						s1.king = setBit(s1.king, neighbor, false);
						s1.activePos = target;
						STK.push(s1);
					}
				}
				if (noJumps) {
					s0.redMove = !s0.redMove;
					s0.king = setBit(s0.king, n, false);
					s0.king = setBit(s0.king, src, true);
					JSUCC.push(s0);
				}
			}
		} //end of WHITE KING
	}

	/**
	 * Sets the value of the nth bit in b to v
	 * @param b
	 * @param n
	 * @param v
	 * @return
	 */
	public static int setBit(int b, byte n, boolean v) {
		if (v) {
			return b | MASKS[n - 1];
		} else {
			return b & ~MASKS[n - 1];
		}
	}

	/**
	 * Instance variables.
	 */
	public byte activePos;
	public int red, white, king;
	public boolean redMove;

	/**
	 * Default constructor.
	 *
	 */
	private State() {

	}
	/**
	 * Copy constructor
	 */
	public State(State s) {
		this.red = s.red;
		this.white = s.white;
		this.king = s.king;
		this.redMove = s.redMove;
		this.activePos = s.activePos;
	}

	public String toString() {
		StringBuffer b = new StringBuffer();
		boolean r, w, k;
		String before, after;
		String line = "---------------------------------\n";
		b.append(line);
		for (int i = 1; i < 33; i++) {
			if (((i - 1) / 4) % 2 == 0) {
				after = "";
				before = "   |";
			} else {
				after = "|   ";
				before = "";
			}
			b.append("|");
			b.append(before);
			r = getBit(red, i);
			w = getBit(white, i);
			k = getBit(king, i);

			if (i < 10)
				b.append("0" + i);
			else
				b.append(i);
			if (r) {
				if (k) {
					b.append("R");
				} else {
					b.append("r");
				}
			} else if (w) {
				if (k) {
					b.append("W");
				} else {
					b.append("w");
				}
			} else {
				b.append(" ");
			}
			b.append(after);
			if (i % 4 == 0) {
				b.append("|\n" + line);
			}
		}
		b.append("[ ");
		//b.append(activePos);
		//b.append(", ");
		if (redMove) {
			b.append("red ]");
		} else {
			b.append("white ]");
		}
		//b.append(" h:" + evaluate(this));
		return b.toString();
	}

	/**
	 * Checks if position i is a neighbor of position j
	 * @param i
	 * @param j
	 * @return
	 */
	public static byte isNeighbor(byte i, byte j) {
		for (byte k = 1; k <= 4; k++) {
			if (S[i][k] == j)
				return k;
		}
		return 0;
	}
	public boolean equals(Object o) {
		State s = (State) o;
		return s.red == red
			&& s.white == white
			&& s.king == king
			&& s.redMove == redMove;
	}

	public static short evaluate(State s) {
		final short END_VALUE = 1000;
		//count material
		byte wP = bitCount(s.white),
			rP = bitCount(s.red),
			wK = bitCount(s.white & s.king),
			rK = bitCount(s.red & s.king);

		//check end
		if (wP == 0)
			return -END_VALUE;
		else if (rP == 0)
			return END_VALUE;

		//components
			int h_pieces = wP - rP, //piece difference [-12,12], maximize
		h_kings = wK - rK, //king difference [-8,8], maximize 
		h_MD = 0, //mobility, maximize
		h_jumps = 0, //min forced jump [0,4], minimize
		h_back = 0, //backrow pieces [0,4], minimize
		h_central = 0, //central pieces, [0,8], maximize
		phase, w_pieces, w_kings, w_MD, w_jumps, w_back, w_central;

		//determine phase
		int totalPieces = rP + wP;
		if (totalPieces >= 18) {
			phase = 1;
			w_pieces = 5;
			w_kings = 5; 
			w_MD = 2; 
			w_jumps = -5;
			w_back = -1; 
			w_central = 2; 
		} else if (totalPieces >= 10) {
			phase = 2;
			w_pieces = 6;
			w_kings = 6; 
			w_MD = 1; 
			w_jumps = -5;
			w_back = -1; 
			w_central = 1; 
		} else if (totalPieces >= 5) {
			phase = 3;
			w_pieces = 7;
			w_kings = 7; 
			w_MD = 1; 
			w_jumps = -7;
			w_back = -2; 
			w_central = 1; 
		} else {
			phase = 4;
			w_pieces = 8;
			w_kings = 8; 
			w_MD = 1; 
			w_jumps = -10;
			w_back = -2; 
			w_central = 2; 
		}

		//calculate color-dependent components
		if (s.redMove) {
			h_back = bitCount(s.red & RED_BACK);
			h_central = bitCount(s.red & CENTRAL);
		} else {
			h_pieces = -h_pieces;
			h_kings = -h_kings;
			h_back = bitCount(s.white & WHITE_BACK);
			h_central = bitCount(s.white & CENTRAL);
		}

		//mobility = number of successors
		Stack succ = makeSuccessors(s);
		h_MD = succ.size();

		//count jumps. jumps are bad
		if (!JSUCC.isEmpty()) {
			//find min forced jump. high forced jumps are bad
			State k;
			int j, minJ = Integer.MAX_VALUE;
			while (!succ.isEmpty()) {
				k = succ.pop();
				if (s.redMove) {
					j = bitCount(s.white ^ k.white);
				} else {
					j = bitCount(s.red ^ k.red);
				}
				if (j < minJ) {
					minJ = j;
				}
			}
			h_jumps = minJ;
		}

		int sum =
			h_pieces * w_pieces
				+ h_kings * w_kings
				+ h_back * w_back
				+ h_central * w_central
				+ h_MD * w_MD
				+ h_jumps * w_jumps;
		//randomize slightly and return
		if(!s.redMove) {
			sum = -sum;
		}
		return (short) (sum + r.nextInt(2*(5-phase)) - 5+phase);
	}
	
	public static boolean isDone(State s) {
		return makeSuccessors(s).isEmpty();
	}

	public static byte bitCount(int x) {
		/*byte c = 0;
		if(getBit(x,32)) {
			c++;
		}
		while(x!=0) {
			c += x%2;
			x = x/2;
		}
		return c;*/
		//parallel sums method 
		// collapse 32x1 bit counts to 16x2 bit counts, mask 01010101 
		x = (x >>> 1 & 0x55555555) + (x & 0x55555555);
		//collapse 16x2 bit counts to 8x4 bit counts, mask 00110011 
		x = (x >>> 2 & 0x33333333) + (x & 0x33333333);
		//collapse 8x4 bit counts to 4x8 bit counts, mask 00001111 
		x = (x >>> 4 & 0x0f0f0f0f) + (x & 0x0f0f0f0f);
		// collapse 4x8 bit counts to 2x16 bit counts 
		x = (x >>> 8 & 0x00ff00ff) + (x & 0x00ff00ff);
		//collapse 2x16 bit counts to 1x32 bit count 
		return (byte) ((x >>> 16) + (x & 0x0000ffff));
	}

}